import { WebContents, IpcRenderer, IpcMain, IpcMainEvent, IpcRendererEvent } from 'electron';
import { AbstractHub, IResponse, IRequest } from 'duplex-message';
export interface IElectronMessageHubOptions {
    channelName?: string;
}
export declare abstract class ElectronMessageHub extends AbstractHub {
    protected readonly _channelName: string;
    protected abstract readonly _ipc: IpcMain | IpcRenderer;
    protected readonly _responseCallbacks: Function[];
    constructor(options?: IElectronMessageHubOptions);
    protected sendMessage(target: WebContents | IpcRenderer, msg: IRequest | IResponse): void;
    protected listenResponse(target: any, reqMsg: IRequest, callback: (resp: IResponse) => boolean): void;
    protected _onMessageReceived(evt: IpcMainEvent | IpcRendererEvent, msg: any): Promise<void>;
}
